// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Fixtures.AcceptanceTestsModelFlattening.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;

    /// <summary>
    /// Additional parameters for the putSimpleProductWithGrouping operation.
    /// </summary>
    [JsonTransformation]
    public partial class FlattenParameterGroup
    {
        /// <summary>
        /// Initializes a new instance of the FlattenParameterGroup class.
        /// </summary>
        public FlattenParameterGroup() { }

        /// <summary>
        /// Initializes a new instance of the FlattenParameterGroup class.
        /// </summary>
        public FlattenParameterGroup(string name, string baseProductId, string maxProductDisplayName, string baseProductDescription = default(string), string odatavalue = default(string))
        {
            Name = name;
            BaseProductId = baseProductId;
            BaseProductDescription = baseProductDescription;
            MaxProductDisplayName = maxProductDisplayName;
            Odatavalue = odatavalue;
        }

        /// <summary>
        /// Product name with value 'groupproduct'
        /// </summary>
        [JsonProperty(PropertyName = "")]
        public string Name { get; set; }

        /// <summary>
        /// Unique identifier representing a specific product for a given
        /// latitude &amp; longitude. For example, uberX in San Francisco
        /// will have a different product_id than uberX in Los Angeles.
        /// </summary>
        [JsonProperty(PropertyName = "")]
        public string BaseProductId { get; set; }

        /// <summary>
        /// Description of product.
        /// </summary>
        [JsonProperty(PropertyName = "")]
        public string BaseProductDescription { get; set; }

        /// <summary>
        /// Display name of product.
        /// </summary>
        [JsonProperty(PropertyName = "")]
        public string MaxProductDisplayName { get; set; }

        /// <summary>
        /// URL value.
        /// </summary>
        [JsonProperty(PropertyName = "")]
        public string Odatavalue { get; set; }

        /// <summary>
        /// Validate the object. Throws ValidationException if validation fails.
        /// </summary>
        public virtual void Validate()
        {
            if (Name == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Name");
            }
            if (BaseProductId == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "BaseProductId");
            }
            if (MaxProductDisplayName == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "MaxProductDisplayName");
            }
        }
    }
}
